#pragma semicolon 1

/*
 *	HP Regeneration
 *	by MaTTe (mateo10)
 */

#define VERSION "1.0.1"

public Plugin:myinfo =
{
	name = "HP Regeneration",
	author = "MaTTe",
	description = "As the title says, this plugin regenerates your hp to maximum",
	version = VERSION,
	url = "http://www.sourcemod.net/"
};

new Handle:g_hRegenTimer[MAXPLAYERS + 1];
new iMaxUse[MAXPLAYERS + 1];

new Handle:g_Interval;
new Handle:g_MaxHP;
new Handle:g_MaxUSE;
new Handle:g_Inc;

public OnPluginStart()
{
	CreateConVar("hpregeneration_version", VERSION, "HP Regeneration Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	g_Interval = CreateConVar("hpregen_interval", "1.0");
	g_MaxHP = CreateConVar("hpregen_maxhp", "100");
	g_MaxUSE = CreateConVar("hpregen_maxuse", "10","number of regenerations per spawn!"); //added by Ben' (http://dodsplugins.mtxserv.fr/)
	g_Inc = CreateConVar("hpregen_inc", "10");

	HookEvent("player_hurt", HookPlayerHurt);
	HookEvent("player_spawn", PlayerSpawnEvent);
}

public PlayerSpawnEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	iMaxUse[client] = 0;
}

public HookPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	new iUserId = GetEventInt(event, "userid");
	new client = GetClientOfUserId(iUserId);

	if(g_hRegenTimer[client] == INVALID_HANDLE)
	{
		g_hRegenTimer[client] = CreateTimer(GetConVarFloat(g_Interval), Regenerate, client, TIMER_REPEAT);
	}
}

public Action:Regenerate(Handle:timer, any:client)
{
	if (ValidPlayer(client,true))
	{
		new ClientHealth = GetClientHealth(client);

		if(iMaxUse[client] <= GetConVarInt(g_MaxUSE))
		{
			iMaxUse[client]++;
			if (ClientHealth + GetConVarInt(g_Inc) < GetConVarInt(g_MaxHP))
			{
				SetClientHealth(client, ClientHealth + GetConVarInt(g_Inc));
			}
			else
			{
				SetClientHealth(client, GetConVarInt(g_MaxHP));
				g_hRegenTimer[client] = INVALID_HANDLE;
				KillTimer(timer);
			}
		}
		else
		{
			g_hRegenTimer[client] = INVALID_HANDLE;
			KillTimer(timer);
		}
	}
	else
	{
		g_hRegenTimer[client] = INVALID_HANDLE;
		KillTimer(timer);
	}
}

SetClientHealth(client, amount)
{
	new HealthOffs = FindDataMapOffs(client, "m_iHealth");
	SetEntData(client, HealthOffs, amount, true);
}

stock bool:ValidPlayer(client,bool:check_alive=false){
	if(client>0 && client<=MaxClients && IsClientConnected(client) && IsClientInGame(client))
	{
		if(check_alive && !IsPlayerAlive(client))
		{
			return false;
		}
		return true;
	}
	return false;
}